\documentclass[10pt,a4paper]{report}
\usepackage[top=3cm, bottom=2.5cm, left=3cm, right=2.5cm] {geometry}
\usepackage {bsymb,b2latex}
\usepackage[utf8]{inputenc}
\usepackage{fancyhdr,lastpage,color}
\lhead{\rm An Event-B Specification of algorithm}
\rhead {\rm Page \thepage~of \pageref{LastPage}}
\lfoot{}\cfoot{}\rfoot{}
\pagestyle{fancy}
%---------------------------------------------------------
\begin{document}
\thispagestyle{empty}
\begin{description}
\BTitle{algorithm}{11Dec2016}{09:45:08 PM}
\MACHINE{algorithm}
\SEES{context}
\VARIABLES
	\begin{description}
		\Item{ z }
		\Item{ y1 }
		\Item{ y2 }
		\Item{ y3 }
		\Item{ l }
	\end{description}
\INVARIANTS
	\begin{description}
		\nItem{ inv1 }{ z \in  \intg   }
		\nItem{ inv2 }{ y1 \in  \intg   }
		\nItem{ inv3 }{ y2 \in  \intg   }
		\nItem{ inv4 }{ y3 \in  \intg   }
		\nItem{ inv5 }{ l \in  L }
		\nItem{ inv6 }{ l=l0 \limp  z\in  \intg  \land  y1 \in  \intg  \land  y2\in  \intg  \land  y3 \in  \intg   }
		\nItem{ inv7 }{ l=l1 \limp  y2=(y1+1)* (y1+1) \land  y3=2* y1+1 \land  y1* y1 \leq  x }
		\nItem{ inv8 }{ l=l2 \limp  y2=(y1+1)* (y1+1) \land  y3=2* y1+1 \land  y2\leq  x }
		\nItem{ inv9 }{ l=l3 \limp  y2=(y1+1)* (y1+1) \land  y3=2* y1+1 \land  y1* y1 \leq  x }
		\nItem{ inv10 }{ l=l4 \limp  y2=(y1+1)* (y1+1) \land  y3=2* y1+1 \land  y1* y1 \leq  x \land  x <  y2 }
		\nItem{ inv11 }{ l=l5 \limp  y2=(y1+1)* (y1+1) \land  y3=2* y1+1 \land  y1* y1 \leq  x \land  x <  y2 \land  z = y1 \land  z* z \leq  x \land  x <  (z+1)* (z+1)  }
		\nItem{ pre }{ x \in  \nat \land  z\in  \intg  \land  y1 \in  \intg  \land y2\in  \intg  \land  y3 \in  \intg  \land  l=l0 \limp  z\in  \intg  \land  y1 \in  \intg  \land y2\in  \intg  \land  y3 \in  \intg   }
		\nItem{ post }{ y2=(y1+1)* (y1+1) \land  y3=2* y1+1 \land  y1* y1 \leq  x \land  x <  y2 \land  z = y1 \land  z* z \leq  x \land  x <  (z+1)* (z+1)  \limp  z* z \leq  x \land  x <  (z+1)* (z+1)  }
	\end{description}
\EVENTS
	\INITIALISATION
		\begin{description}
		\BeginAct
			\begin{description}
			\nItem{ act1 }{ z :\in  \intg   }
			\nItem{ act2 }{ y1 :\in  \intg  }
			\nItem{ act3 }{ y2 :\in  \intg   }
			\nItem{ act4 }{ y3 :\in  \intg   }
			\nItem{ act5 }{ l :=  l0 }
			\end{description}
		\EndAct
		\end{description}
	\EVT {el0l1}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ l=l0 }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ l:= l1 }
			\nItem{ act2 }{ y1:= 0 }
			\nItem{ act3 }{ y2:= 1 }
			\nItem{ act4 }{ y3:= 1 }
			\end{description}
		\EndAct
		\end{description}
	\EVT {el1l2}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ l=l1 }
			\nItem{ grd2 }{ y2\leq x }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ l:= l2 }
			\end{description}
		\EndAct
		\end{description}
	\EVT {el2l3}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ l=l2 }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ l:= l3 }
			\nItem{ act2 }{ y1:= y1+1 }
			\nItem{ act3 }{ y2:= y2+y3+2 }
			\nItem{ act4 }{ y3:= y3+2 }
			\end{description}
		\EndAct
		\end{description}
	\EVT {el3l2}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ l=l3 }
			\nItem{ grd2 }{ y2\leq x }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ l:= l2 }
			\end{description}
		\EndAct
		\end{description}
	\EVT {el3l4}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ l=l3 }
			\nItem{ grd2 }{ y2> x }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ l:= l4 }
			\end{description}
		\EndAct
		\end{description}
	\EVT {el1l4}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ l=l1 }
			\nItem{ grd2 }{ y2> x }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ l:= l4 }
			\end{description}
		\EndAct
		\end{description}
	\EVT {el4l5}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ l=l4 }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ l:= l5 }
			\nItem{ act2 }{ z:= y1 }
			\end{description}
		\EndAct
		\end{description}
\END
\end{description}
\end{document}
